#include <stdio.h>
#include <math.h>
#include "log.h"
#include "pgm.h"

int Num_Orientations = 4;
int Threshold = 0;

main(int argc, char* argv[])
{
  int width, height, max;
  int i, j;
  int size;

/*  unsigned char *edge_map1[Num_Orientations], *edge_map2[Num_Orientations];*/
  unsigned char **edge_map1, **edge_map2;
  unsigned char *image;
  char base[20], fname[35];

  edge_map1 = (unsigned char **)
			calloc(Num_Orientations, sizeof(unsigned char *));
  edge_map2 = (unsigned char **)
			calloc(Num_Orientations, sizeof(unsigned char *));

  max=read_pgm(argv[1], &image, &width, &height);
  size=width*height;
  write_pgm("temp.pgm", image, width, height, max);

  Edges(width, height, size, edge_map1, image);

  strncpy(base, argv[1], strlen(argv[1])-3);
  base[strlen(argv[1])-3]=0;
  sprintf(fname, "%see000.pgm", base);
  write_pgm(fname, edge_map1[0], width, height, max);
  sprintf(fname, "%see045.pgm", base);
  write_pgm(fname, edge_map1[1], width, height, max);
  sprintf(fname, "%see090.pgm", base);
  write_pgm(fname, edge_map1[2], width, height, max);
  sprintf(fname, "%see135.pgm", base);
  write_pgm(fname, edge_map1[3], width, height, max);

}


void Edges(int width, int height, int size, unsigned char **edge_map,
		unsigned char *image)
{
/*
  int i, j, edge;
  int radius=1;
  char f_name[20];
  int edges[size];
  double mag[size];
  char base[20], fname[35];
  int max=255;
*/

  double **logMask;
  double *temp_map[4];
  double *smoothed_im;
  int sigma=1;
  int x, y, i;

  logMask=(double**) calloc(6*sigma+1, sizeof(double *));
  for(x=0; x<6*sigma+1; x++)
    logMask[x]=(double *) calloc(6*sigma+1, sizeof(double));

  for (i=0; i<Num_Orientations; i++)
  {
    temp_map[i]=(double *) calloc(size, sizeof(double));
    edge_map[i]=(unsigned char *) calloc(size, 1);
  }

  smoothed_im=(double*) calloc(width*height, sizeof(double));
  
  createLOG(logMask, sigma);
  convolveLOG(image, width, logMask, 3*sigma, smoothed_im);
  findzeros(smoothed_im, temp_map, width);

  MultipleNormalize(size, edge_map, temp_map);

/*
  for(i=0; i<size; i++)
    edges[i]=-1;

  for (i=0; i<Num_Orientations; i++)
  {
    temp_map[i]=(double *) calloc(size, sizeof(double));
    edge_map[i]=(unsigned char *) calloc(size, 1);
  }

  for (i=radius; i<height-radius; i++)
  {
    for (j=radius; j<width-radius; j++)
    {
      edges[i*width+j]=Sobel(i, j, width, image, mag);
    }
  }

  create_maps(edges, temp_map, size, mag);

  MultipleNormalize(size, edge_map, temp_map);
*/
}

void createLOG(double **operator, int sigma)
{
  int x, y;
  double frac, val;

  for (x=0; x<=3*sigma; x++)
    for (y=0; y<=3*sigma; y++)
    {
      frac=(double)(x*x+y*y)/(double)(2*sigma*sigma);
/*      printf("x=%d, y=%d, frac=%g\n", x, y, frac);*/
      val=(1-frac)*exp(-frac);
      operator[3*sigma-x][3*sigma-y]=val;
      operator[3*sigma-x][3*sigma+y]=val;
      operator[3*sigma+x][3*sigma-y]=val;
      operator[3*sigma+x][3*sigma+y]=val;
    }

/*
  for (y=0; y<6*sigma+1; y++)
  {
    for(x=0; x<6*sigma+1; x++)
      printf("%g\t", operator[x][y]);
    printf("\n");
  }
*/
}

void convolveLOG(unsigned char *image, int width, double **operator, 
		 int rad_op, double *new_map)
{
  int im_x, im_y;
  int op_x, op_y;
  double val;
  int dir, i;
  double max;

  for(im_y=rad_op; im_y<width-rad_op; im_y++)
    for(im_x=rad_op; im_x<width-rad_op; im_x++)
    {
      val=0;
      for(op_y=-rad_op; op_y<=rad_op; op_y++)
        for(op_x=-rad_op; op_x<=rad_op; op_x++)
	{
	  val+=image[(im_y+op_y)*width+(im_x+op_x)]*
			operator[op_y+rad_op][op_x+rad_op];
	}
      new_map[im_y*width+im_x]=val;
    }
}

void findzeros(double *smoothed, double **temp_maps, int width)
{
  int x, y;
  double diffs[4]; /* 0=horiz, 1=45deg, 2=horiz, 3=135deg */
  double max;
  int dir, i;

  for(x=1; x<width-1; x++)
    for(y=1; y<=width-1; y++)
    {
      if((smoothed[y*width+x]*smoothed[y*width+x+1]<=0) ||
	 (smoothed[y*width+x]*smoothed[(y+1)*width+x]<=0))
      {
	diffs[2]=abs(smoothed[y*width+x]-smoothed[y*width+x+1]);
	diffs[0]=abs(smoothed[y*width+x]-smoothed[(y+1)*width+x]);
	diffs[1]=abs(smoothed[y*width+x]-smoothed[(y+1)*width+(x+1)]);
	diffs[3]=abs(smoothed[y*width+x]-smoothed[(y-1)*width+(x+1)]);

        if(diffs[0] || diffs[1] || diffs[2] ||diffs[3])
        {

	  /*
  	  max=0;
	  dir=0;
          for(i=0; i<4; i++)
	    if (diffs[i]>max) 
	    {
	      max=diffs[i];
	      dir=i;
	    }
	  temp_maps[dir][y*width+x]=max;
	  */
        }
      }
    }
}
void create_maps(int *edges, double **maps, int size, double *mag)
{
  int focus, i;
  double diff, max_mag;
  double Threshold=0;

  for (focus=0; focus<Num_Orientations; focus++)
    for(i=0; i<size; i++)
    {
      if (edges[i]<0) maps[focus][i]=0;
      else
      {
	diff=fabs(focus*(180/Num_Orientations)-edges[i]);
	if (diff>90.0) diff=180-diff;
	if (diff>180/Num_Orientations/2) diff=90;
	else diff=0;
        if (mag[i]>Threshold*max_mag)
          maps[focus][i]=(90.0-diff);
        else
          maps[focus][i]=0;

/*/
	maps[focus][i]=(90.0-diff)*mag[i];
*/
      }
    }
  
}

int Sobel(int i, int j, int width, unsigned char *image, double *mag)
{
  float temp;
  double Sx, Sy, ratio;
  int result;

  static int X[9] = {-1,  0,  1,
		     -2,  0,  2,
		     -1,  0,  1 };

  static int Y[9] = {-1, -2, -1,
		      0,  0,  0,
		      1,  2,  1 };

  Sx=Grad(i, j, width, X, image);
  Sy=Grad(i, j, width, Y, image);
  mag[i*width+j]=sqrt(Sx*Sx+Sy*Sy);

  if (Sy==0.0)
  {
    if (Sx==0.0)  result=-1;
    else result=90;
  }
  else
  {
    ratio=Sx/Sy;
    if ((result=atan(ratio)*180/M_PI) < 0)
      result+=180;
  }

  return result;
}


double Grad(int i, int j, int width, int mask[9], unsigned char *image)
{
  int x, y;
  double total=0.0;
  int temp;

  i--; j--;

  for(y=0; y<3; y++)
    for(x=0; x<3; x++)
    {
      temp = mask[y*3+x] * image[(i+y)*width + (j+x)];
      total+=temp;
    }

  return total;

}



void MultipleNormalize(int size, unsigned char **e_map, double **t_map)
{
  int i;
  double currMax, maxVal = 0.0;
  
  for(i=0; i< Num_Orientations; i++)
  {
    currMax = Maximum(size, t_map[i]);
    if (currMax > maxVal)
       maxVal=currMax;
  }

  for(i=0; i< Num_Orientations; i++)

    Normalize(i, maxVal, size, e_map, t_map);

  return;
}  



void Normalize (int edge, int maxValue, int size, unsigned char **e_map,
		double **temp_map)
{
  int i;
  float multFac;

  multFac=255.0/maxValue;

  for(i=0; i<size; i++)
  {
    e_map[edge][i]=(unsigned char)(temp_map[edge][i]*multFac);
    if (e_map[edge][i]<Threshold) e_map[edge][i]=0;
  }
}



float Maximum(int size, double *temp_map)
{
  int i;
  double max=0;

  for (i=0; i<size; i++)
  {
    if (temp_map[i]>max)
      max=temp_map[i];
  }

  return max;
}

